//---------------------------------------------------------------------------
// Copyright (C) 1997-2008 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: CHMIGCdestination
//
// Description:
//
// Implementation
//
// Author: Steven Dodd
// Date:   Jan 20, 2009
// Revision: $Revision: 1.4 $
//
// Last Edit Date: $Date: 2009-01-28 16:17:05 $
// Source: $Source: /home/cvs/cvsroot/CHM/Attic/CHMIGCdestination.cpp,v $
//---------------------------------------------------------------------------
#include "CHMpreCompHead.h"
#pragma hdrstop

#ifdef CHM_NO_PRECOMPILED_HEADERS
#  include <CHM/CHMIGCdestination.h>
#endif

void CHM_STD_CALL CHMIGCdestinationOnMessageReceivedCallback
(
   void* StubHandle,
   const char* Message,
   void* pMessageResponse
)
{
   //construct stub wrappers for internal complex parameters
   CHMIGCdestination* pThis = ((CHMIGCdestination*)StubHandle);
   CHMIGCmessageReceivedResponse MessageResponseWrapper(pThis->dll(),pMessageResponse);
   pThis->onMessageReceived(Message, MessageResponseWrapper);
}

void CHM_STD_CALL CHMIGCdestinationOnMessageResubmitPreviewCallback
(
   void* StubHandle,
   const char* Message,
   void* pMessageResponse
)
{
   //construct stub wrappers for internal complex parameters
   CHMIGCdestination* pThis = ((CHMIGCdestination*)StubHandle);
   CHMIGCmessageReceivedResponse MessageResponseWrapper(pThis->dll(),pMessageResponse);
   pThis->onPreviewMessageReceived(Message, MessageResponseWrapper);
}

void CHM_STD_CALL CHMIGCdestinationOnShutdownRequestCallback
(
   void* StubHandle
)
{
   //construct stub wrappers for internal complex parameters   
   CHMIGCdestination* pThis = ((CHMIGCdestination*)StubHandle);
   pThis->onShutdownDestination();
}

void CHM_STD_CALL CHMIGCdestinationOnDisconnectCallback
(
   void* StubHandle,
   CHMuint32 DisconnectReasonFlags_,
   const char* DisconnectReasonDescription
)
{
   //construct stub wrappers for internal complex parameters   
   CHMIGCdestination* pThis = ((CHMIGCdestination*)StubHandle);
   // strip off possible future flags unknown to this client - future flagsets will be constructed with this in mind
   // e.g. future specific error flagsets should have CHMIGC_DISCONNECT_BY_ERROR set as well as additional subflags
   CHMIGCdisconnectReasonFlags DisconnectReasonFlags = (CHMIGCdisconnectReasonFlags)(DisconnectReasonFlags_ & CHMIGC_DISCONNECT_ALL);
   pThis->onDisconnectDestination(DisconnectReasonFlags, DisconnectReasonDescription);
}

CHMIGCdestination::CHMIGCdestination(CHMIGCdll& iDll)
:
   Dll(iDll)
{
   Handle = Dll.messageProcessorCreate(this);
   Dll.connectForMessageReceived(Handle, CHMIGCdestinationOnMessageReceivedCallback);
   Dll.connectForMessageResubmitPreview(Handle, CHMIGCdestinationOnMessageResubmitPreviewCallback);
   Dll.connectForShutdownRequest(Handle, CHMIGCdestinationOnShutdownRequestCallback);
   Dll.connectForDisconnect(Handle,CHMIGCdestinationOnDisconnectCallback);
}

CHMIGCdestination::~CHMIGCdestination()
{
   Dll.messageProcessorDestroy(Handle);
}

void CHMIGCdestination::connectDestination(const CHMstring& Host, CHMuint16 Port, const CHMstring& ChannelName)
{
   CHMstring ChannelId = ChannelName + ".dest1";
   Dll.messageProcessorConnect(Handle, Host.c_str(), Port, ChannelId.c_str());
}

void CHMIGCdestination::disconnectDestination()
{
   Dll.messageProcessorDisconnect(Handle);
}

void CHMIGCdestination::setDebugFileName(const CHMstring& FileName)
{
   Dll.messageProcessorSetDebugFileName(Handle,FileName.c_str());
}
