//---------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: CHMIGCmessageReceivedResponse
//
// Description:
//
// Implementation
//
// Author: Steven Dodd
// Date:   Jan 20, 2009
// Revision: $Revision: 1.3 $
//
// Last Edit Date: $Date: 2009-02-13 17:30:37 $
// Source: $Source: /home/cvs/cvsroot/CHM/Attic/CHMIGCmessageReceivedResponse.cpp,v $
//---------------------------------------------------------------------------
#include "CHMpreCompHead.h"
#pragma hdrstop

#ifdef CHM_NO_PRECOMPILED_HEADERS
#  include <CHM/CHMIGCmessageReceivedResponse.h>
#  include <CHM/CHMIGCdll.h>
#endif

CHMIGCmessageReceivedResponse::CHMIGCmessageReceivedResponse(CHMIGCdll& iDll, void* iResponseHandle)
:
   Dll(iDll),
   ResponseHandle(iResponseHandle)
{
}

CHMIGCmessageReceivedResponse::~CHMIGCmessageReceivedResponse()
{
   //this object's lifetime is managed inside the dll
}

CHMboolean CHMIGCmessageReceivedResponse::messageProcessed() const
{
   return Dll.messageReceivedGetResponseProcessed(ResponseHandle);
}

void CHMIGCmessageReceivedResponse::setMessageProcessed(CHMboolean NewValue)
{
   Dll.messageReceivedResponseSetProcessed(ResponseHandle, NewValue);   
}

CHMboolean CHMIGCmessageReceivedResponse::stopChannel() const
{
   return Dll.messageReceivedResponseGetStopChannel(ResponseHandle);
}

void CHMIGCmessageReceivedResponse::setStopChannel( CHMboolean NewValue )
{
   Dll.messageReceivedResponseSetStopChannel(ResponseHandle,NewValue);
}

void CHMIGCmessageReceivedResponse::setStopChannelErrorFlag(CHMboolean NewValue)
{
   Dll.messageReceivedResponseSetStopChannelErrorFlag(ResponseHandle,NewValue);
}

CHMboolean CHMIGCmessageReceivedResponse::stopChannelErrorFlag() const
{
   return Dll.messageReceivedResponseGetStopChannelErrorFlag(ResponseHandle);
}

void CHMIGCmessageReceivedResponse::setStopChannelReason(const CHMstring& NewValue)
{
   Dll.messageReceivedResponseSetStopChannelReason(ResponseHandle,NewValue.c_str());
}

CHMstring CHMIGCmessageReceivedResponse::stopChannelReason() const
{
   return Dll.messageReceivedResponseGetStopChannelReason(ResponseHandle);
}

CHMboolean CHMIGCmessageReceivedResponse::resendMessage() const
{
   return Dll.messageReceivedResponseGetResendMessage(ResponseHandle);
}

void CHMIGCmessageReceivedResponse::setResendMessage( CHMboolean NewValue )
{
   Dll.messageReceivedResponseSetResendMessage(ResponseHandle,NewValue);
}

CHMuint32 CHMIGCmessageReceivedResponse::resendMessageDelay() const
{
   return Dll.messageReceivedResponseGetResendMessageDelay(ResponseHandle);
}

void CHMIGCmessageReceivedResponse::setResendMessageDelay( CHMuint32 NewValue )
{
   Dll.messageReceivedResponseSetResendMessageDelay(ResponseHandle,NewValue);
}

void CHMIGCmessageReceivedResponse::addLogMessage(CHMIGClogMessageType LogMessageType, const CHMstring& LogMessage)
{
   Dll.messageReceivedResponseAddLogMessage(ResponseHandle, LogMessageType, LogMessage.c_str());
}

void CHMIGCmessageReceivedResponse::addLogValue(const CHMstring& Key, const CHMstring& Value)
{
   Dll.messageReceivedResponseAddLog(ResponseHandle, Key.c_str(), Value.c_str());
}

void CHMIGCmessageReceivedResponse::removeLogValue(const CHMstring& Key)
{
   Dll.messageReceivedResponseRemoveLog(ResponseHandle, Key.c_str());
}

CHMstring CHMIGCmessageReceivedResponse::logValue(const CHMstring& Key)
{
   return Dll.messageReceivedResponseGetLog(ResponseHandle, Key.c_str());
}

