//---------------------------------------------------------------------------
// Copyright (C) 1997-2009 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: CHMIGCmessageRequestResponse
//
// Description:
//
// Implementation
//
// Author: Steven Dodd
// Date:   Jan 20, 2009
// Revision: $Revision: 1.3 $
//
// Last Edit Date: $Date: 2009-02-13 17:30:37 $
// Source: $Source: /home/cvs/cvsroot/CHM/Attic/CHMIGCmessageRequestResponse.cpp,v $
//---------------------------------------------------------------------------
#include "CHMpreCompHead.h"
#pragma hdrstop

#ifdef CHM_NO_PRECOMPILED_HEADERS
#  include <CHM/CHMIGCmessageRequestResponse.h>
#  include <CHM/CHMIGCdll.h>
#endif

CHMIGCmessageRequestResponse::CHMIGCmessageRequestResponse(CHMIGCdll& iDll, void* iResponseHandle)
:
   Dll(iDll),
   ResponseHandle(iResponseHandle)
{
}

CHMIGCmessageRequestResponse::~CHMIGCmessageRequestResponse()
{
}

void CHMIGCmessageRequestResponse::setOutboundMessage(const CHMstring& NewValue)
{
   Dll.messageRequestResponseSetMessage(ResponseHandle,NewValue.c_str());
}

CHMstring CHMIGCmessageRequestResponse::outboundMessage() const
{
   return Dll.messageRequestResponseGetMessage(ResponseHandle);
}

void CHMIGCmessageRequestResponse::setMessageIsError(CHMboolean IsError)
{
   Dll.messageRequestResponseSetIsError(ResponseHandle,IsError);
}

CHMboolean CHMIGCmessageRequestResponse::messageIsError() const
{
   return Dll.messageRequestResponseGetIsError(ResponseHandle);
}

void CHMIGCmessageRequestResponse::setMessageId(const CHMstring& MessageId)
{
   Dll.messageRequestResponseSetMessageId(ResponseHandle,MessageId.c_str());
}

CHMstring CHMIGCmessageRequestResponse::messageId() const
{
   return Dll.messageRequestResponseGetMessageId(ResponseHandle);
}

void CHMIGCmessageRequestResponse::setStopChannel(CHMboolean NewValue)
{
   Dll.messageRequestResponseSetStopChannel(ResponseHandle,NewValue);
}

CHMboolean CHMIGCmessageRequestResponse::stopChannel() const
{
   return Dll.messageRequestResponseGetStopChannel(ResponseHandle);
}

void CHMIGCmessageRequestResponse::setStopChannelErrorFlag(CHMboolean NewValue)
{
   Dll.messageRequestResponseSetStopChannelErrorFlag(ResponseHandle,NewValue);
}

CHMboolean CHMIGCmessageRequestResponse::stopChannelErrorFlag() const
{
   return Dll.messageRequestResponseGetStopChannelErrorFlag(ResponseHandle);
}

void CHMIGCmessageRequestResponse::setStopChannelReason(const CHMstring& NewValue)
{
   Dll.messageRequestResponseSetStopChannelReason(ResponseHandle,NewValue.c_str());
}

CHMstring CHMIGCmessageRequestResponse::stopChannelReason() const
{
   return Dll.messageRequestResponseGetStopChannelReason(ResponseHandle);
}

void CHMIGCmessageRequestResponse::addLogMessage(CHMIGClogMessageType LogMessageType, const CHMstring& LogMessage)
{
   Dll.messageRequestResponseAddLogMessage(ResponseHandle, LogMessageType, LogMessage.c_str());
}

void CHMIGCmessageRequestResponse::addLogValue(const CHMstring& Key, const CHMstring& Value)
{
   Dll.messageRequestResponseAddLog(ResponseHandle, Key.c_str(), Value.c_str());
}

void CHMIGCmessageRequestResponse::removeLogValue(const CHMstring& Key)
{
   Dll.messageRequestResponseRemoveLog(ResponseHandle, Key.c_str());
}

CHMstring CHMIGCmessageRequestResponse::logValue(const CHMstring& Key)
{
   return Dll.messageRequestResponseGetLog(ResponseHandle, Key.c_str());
}
