//---------------------------------------------------------------------------
// Copyright (C) 1997-2008 iNTERFACEWARE Inc.  All Rights Reserved
//
// Module: CHMIGCsource
//
// Description:
//
// Implementation
//
// Author: Eliot Muir
// Date:   Monday, May 12th, 2008 @ 03:50:35 AM
// Revision: $Revision: 1.4 $
//
// Last Edit Date: $Date: 2009-01-28 16:17:05 $
// Source: $Source: /home/cvs/cvsroot/CHM/Attic/CHMIGCsource.cpp,v $
//---------------------------------------------------------------------------
#include "CHMpreCompHead.h"
#pragma hdrstop

#ifdef CHM_NO_PRECOMPILED_HEADERS
#  include <CHM/CHMIGCsource.h>
#endif

void CHM_STD_CALL CHMIGCsourceOnMessageRequestCallback
(
   void* StubHandle,
   void* pMessageResponse
)
{
   //construct stub wrappers for internal complex parameters
   CHMIGCsource* pThis = ((CHMIGCsource*)StubHandle);
   CHMIGCmessageRequestResponse MessageResponseWrapper(pThis->dll(),pMessageResponse);
   pThis->onMessageRequest(MessageResponseWrapper);
}

void CHM_STD_CALL CHMIGCsourceOnMessageRequestCompletedCallback
(
   void* StubHandle,
   const char* pMessageId,
   CHMboolean Processed
)
{
   CHMIGCsource* pThis = ((CHMIGCsource*)StubHandle);
   pThis->onMessageRequestCompleted(pMessageId,Processed);
}

void CHM_STD_CALL CHMIGCsourceOnShutdownRequestCallback
(
   void* StubHandle
)
{
   //construct stub wrappers for internal complex parameters   
   CHMIGCsource* pThis = ((CHMIGCsource*)StubHandle);
   pThis->onShutdownSource();
}

void CHM_STD_CALL CHMIGCsourceOnDisconnectCallback
(
   void* StubHandle,
   CHMuint32 DisconnectReasonFlags_,
   const char* DisconnectReasonDescription
)
{
   //construct stub wrappers for internal complex parameters   
   CHMIGCsource* pThis = ((CHMIGCsource*)StubHandle);
   // strip off possible future flags unknown to this client - future flagsets will be constructed with this in mind
   // e.g. future specific error flagsets should have CHMIGC_DISCONNECT_BY_ERROR set as well as additional subflags
   CHMIGCdisconnectReasonFlags DisconnectReasonFlags = (CHMIGCdisconnectReasonFlags)(DisconnectReasonFlags_ & CHMIGC_DISCONNECT_ALL);
   pThis->onDisconnectSource(DisconnectReasonFlags, DisconnectReasonDescription);
}

CHMIGCsource::CHMIGCsource(CHMIGCdll& iDll)
:
   Dll(iDll)
{
   Handle = Dll.messageProcessorCreate(this);
   Dll.connectForMessageRequest(Handle, CHMIGCsourceOnMessageRequestCallback);
   Dll.connectForMessageRequestCompleted(Handle, CHMIGCsourceOnMessageRequestCompletedCallback);
   Dll.connectForShutdownRequest(Handle, CHMIGCsourceOnShutdownRequestCallback);
   Dll.connectForDisconnect(Handle,CHMIGCsourceOnDisconnectCallback);
}

CHMIGCsource::~CHMIGCsource()
{
   Dll.messageProcessorDestroy(Handle);
}

void CHMIGCsource::setDebugFileName(const CHMstring& FileName)
{
   Dll.messageProcessorSetDebugFileName(Handle,FileName.c_str());
}

void CHMIGCsource::connectSource(const CHMstring& Host, CHMuint16 Port, const CHMstring& ChannelName)
{
   CHMstring ClientId = ChannelName + ".source1";
   Dll.messageProcessorConnect(Handle, Host.c_str(), Port, ClientId.c_str());
}
   
void CHMIGCsource::disconnectSource()
{
   Dll.messageProcessorDisconnect(Handle);
}
