//--------------------------------------------------------------------------
// Class: CHMlicense
//
// Description:
//
// Implementation
//
// Automatically generated class file.
// DO NOT EDIT.
//--------------------------------------------------------------------------
#include <CHM/CHMpreCompHead.h>
#pragma hdrstop

#include <CHM/CHMlicense.h>
#include <CHM/CHMlicenseDll.h>
#include <CHM/CHMerrorClass.h>
#include <CHM/CHMutilsDll.h>

CHMlicense::CHMlicense()
{
   CHM_CHECK_CALL(CHMlicenseCreate(&Handle));
   CHM_CHECK_CALL(CHMlicenseAddRef(Handle));
}

CHMlicense::CHMlicense(CHMlicenseHandle iHandle)
{
   Handle = iHandle;
   if (Handle)
   {
      CHM_CHECK_CALL(CHMlicenseAddRef(Handle));
   }
}

CHMlicense::CHMlicense(const CHMlicense& Orig)
{
   Handle = Orig.Handle;
   if (Handle)
   {
      CHM_CHECK_CALL(CHMlicenseAddRef(Handle));
   }
}

CHMlicense& CHMlicense::operator=(const CHMlicense& Orig)
{
   Handle = Orig.Handle;
   if (Handle)
   {
      CHM_CHECK_CALL(CHMlicenseAddRef(Handle));
   }
   return *this;
}

CHMlicense::~CHMlicense()
{
   if (Handle)
   {
      CHM_CHECK_CALL(CHMlicenseRelease(Handle));
   }
}

CHMboolean CHMlicense::IsLicensed() const
{
   CHM_ASSERT(Handle != NULL);
   CHMboolean ReturnValue;
   CHM_CHECK_CALL(CHMlicenseGetIsLicensed(Handle, &ReturnValue));
   return ReturnValue;
}

const char* CHMlicense::Proxy() const
{
   CHM_ASSERT(Handle != NULL);
   const char* ReturnValue;
   CHM_CHECK_CALL(CHMlicenseGetProxy(Handle, &ReturnValue));
   return ReturnValue;
}

void CHMlicense::SetProxy(const char* Value)
{
   CHM_ASSERT(Handle != NULL);
   CHM_CHECK_CALL(CHMlicenseSetProxy(Handle, Value));
}

const char* CHMlicense::MachineId() const
{
   CHM_ASSERT(Handle != NULL);
   const char* ReturnValue;
   CHM_CHECK_CALL(CHMlicenseGetMachineId(Handle, &ReturnValue));
   return ReturnValue;
}

const char* CHMlicense::FetchRegistrationCode(const char* MachineId, const char* EmailAddress, const char* Password, const char* Description)
{
   CHM_ASSERT(Handle != NULL);
   const char* ReturnValue;
   CHM_CHECK_CALL(CHMlicenseFetchRegistrationCode(Handle, MachineId, EmailAddress, Password, Description, &ReturnValue));
   return ReturnValue;
}

void CHMlicense::RegisterHost(const char* RegistrationCode)
{
   CHM_ASSERT(Handle != NULL);
   CHM_CHECK_CALL(CHMlicenseRegisterHost(Handle, RegistrationCode));
}

const char* CHMlicense::FetchTrialRegistrationCode(time_t& ExpiryDate, const char* MachineId, const char* EmailAddress, const char* Password, const char* Description)
{
   CHM_ASSERT(Handle != NULL);
   double DtExpiryDate = 0;
   const char* ReturnValue;
   CHM_CHECK_CALL(CHMlicenseFetchTrialRegistrationCode(Handle, &DtExpiryDate, MachineId, EmailAddress, Password, Description, &ReturnValue));
   CHM_CHECK_CALL(CHMoleDateToTimeT(DtExpiryDate, (CHMint32*) &ExpiryDate));
   return ReturnValue;
}

void CHMlicense::RegisterTrialHost(const char* RegistrationCode, time_t ExpiryDate)
{
   CHM_ASSERT(Handle != NULL);
   double DtExpiryDate = 0;
   CHM_CHECK_CALL(CHMtimeTToOleDate(ExpiryDate, &DtExpiryDate));
   CHM_CHECK_CALL(CHMlicenseRegisterTrialHost(Handle, RegistrationCode, DtExpiryDate));
}


