//--------------------------------------------------------------------------
// Class: CHMllpServer
//
// Description:
//
// Implementation
//
// Automatically generated class file.
// DO NOT EDIT.
//--------------------------------------------------------------------------
#include <CHM/CHMpreCompHead.h>
#pragma hdrstop

#include <CHM/CHMllpConnection.h>
#include <CHM/CHMllpServer.h>
#include <CHM/CHMlistenerDll.h>
#include <CHM/CHMerrorClass.h>
#include <CHM/CHMutilsDll.h>

CHMllpServer::CHMllpServer()
{
   CHM_CHECK_CALL(CHMlistenerCreate(&Handle));
   setup();
   CHM_CHECK_CALL(CHMlistenerAddListener(Handle, (void*)this));
   CHM_CHECK_CALL(CHMlistenerAddRef(Handle));
}

CHMllpServer::CHMllpServer(CHMlistenerHandle iHandle)
{
   Handle = iHandle;
   if (Handle)
   {
      CHM_CHECK_CALL(CHMlistenerAddRef(Handle));
   }
}

CHMllpServer::CHMllpServer(const CHMllpServer& Orig)
{
   Handle = Orig.Handle;
   if (Handle)
   {
      CHM_CHECK_CALL(CHMlistenerAddRef(Handle));
   }
}

CHMllpServer& CHMllpServer::operator=(const CHMllpServer& Orig)
{
   Handle = Orig.Handle;
   if (Handle)
   {
      CHM_CHECK_CALL(CHMlistenerAddRef(Handle));
   }
   return *this;
}

CHMllpServer::~CHMllpServer()
{
   CHM_CHECK_CALL(CHMlistenerRemoveListener(Handle, (void*)this));
   if (Handle)
   {
      CHM_CHECK_CALL(CHMlistenerRelease(Handle));
   }
}

CHMint32 CHMllpServer::Port() const
{
   CHM_ASSERT(Handle != NULL);
   CHMint32 ReturnValue;
   CHM_CHECK_CALL(CHMlistenerGetPort(Handle, &ReturnValue));
   return ReturnValue;
}

const char* CHMllpServer::Host() const
{
   CHM_ASSERT(Handle != NULL);
   const char* ReturnValue;
   CHM_CHECK_CALL(CHMlistenerGetHost(Handle, &ReturnValue));
   return ReturnValue;
}

void CHMllpServer::SetHost(const char* Value)
{
   CHM_ASSERT(Handle != NULL);
   CHM_CHECK_CALL(CHMlistenerSetHost(Handle, Value));
}

const char* CHMllpServer::HeaderBlock() const
{
   CHM_ASSERT(Handle != NULL);
   const char* ReturnValue;
   CHM_CHECK_CALL(CHMlistenerGetHeaderBlock(Handle, &ReturnValue));
   return ReturnValue;
}

void CHMllpServer::SetHeaderBlock(const char* Value)
{
   CHM_ASSERT(Handle != NULL);
   CHM_CHECK_CALL(CHMlistenerSetHeaderBlock(Handle, Value));
}

const char* CHMllpServer::TrailerBlock() const
{
   CHM_ASSERT(Handle != NULL);
   const char* ReturnValue;
   CHM_CHECK_CALL(CHMlistenerGetTrailerBlock(Handle, &ReturnValue));
   return ReturnValue;
}

void CHMllpServer::SetTrailerBlock(const char* Value)
{
   CHM_ASSERT(Handle != NULL);
   CHM_CHECK_CALL(CHMlistenerSetTrailerBlock(Handle, Value));
}

CHMboolean CHMllpServer::IsListening() const
{
   CHM_ASSERT(Handle != NULL);
   CHMboolean ReturnValue;
   CHM_CHECK_CALL(CHMlistenerGetIsListening(Handle, &ReturnValue));
   return ReturnValue;
}

CHMboolean CHMllpServer::IsValidSocketHandle() const
{
   CHM_ASSERT(Handle != NULL);
   CHMboolean ReturnValue;
   CHM_CHECK_CALL(CHMlistenerGetIsValidSocketHandle(Handle, &ReturnValue));
   return ReturnValue;
}

CHMint32 CHMllpServer::SocketHandle() const
{
   CHM_ASSERT(Handle != NULL);
   CHMint32 ReturnValue;
   CHM_CHECK_CALL(CHMlistenerGetSocketHandle(Handle, &ReturnValue));
   return ReturnValue;
}

CHMllpConnection CHMllpServer::Client(CHMint32 ClientIndex) const
{
   CHM_ASSERT(Handle != NULL);
   CHMconnectionHandle ReturnValue;
   CHM_CHECK_CALL(CHMlistenerGetConnection(Handle, ClientIndex, &ReturnValue));
   return CHMllpConnection(ReturnValue);
}

CHMint32 CHMllpServer::CountOfClient() const
{
   CHM_ASSERT(Handle != NULL);
   CHMint32 ReturnValue;
   CHM_CHECK_CALL(CHMlistenerCountOfConnection(Handle, &ReturnValue));
   return ReturnValue;
}

void CHMllpServer::StopMessageLoop()
{
   CHM_ASSERT(Handle != NULL);
   CHM_CHECK_CALL(CHMlistenerStopMessageLoop(Handle));
}

void CHMllpServer::RunMessageLoop()
{
   CHM_CHECK_CALL(CHMlistenerRunMessageLoop());
}

void CHMllpServer::StartListen(CHMint32 Port)
{
   CHM_ASSERT(Handle != NULL);
   CHM_CHECK_CALL(CHMlistenerStartListen(Handle, Port));
}

const char* CHMllpServer::MakeMessagePrintable(const char* InputString, const char* NewLine, CHMint32 MaximumLength)
{
   CHM_ASSERT(Handle != NULL);
   const char* ReturnValue;
   CHM_CHECK_CALL(CHMlistenerMakePrintable(Handle, InputString, NewLine, MaximumLength, &ReturnValue));
   return ReturnValue;
}

void CHMllpServer::StopListen()
{
   CHM_ASSERT(Handle != NULL);
   CHM_CHECK_CALL(CHMlistenerStopListen(Handle));
}

void CHMllpServer::DisconnectAllClients()
{
   CHM_ASSERT(Handle != NULL);
   CHM_CHECK_CALL(CHMlistenerCloseAll(Handle));
}

static CHMresult CHM_STD_CALL CHMllpServerErrorReceived
(
   void* pLlpServer,
   const char* ErrorMessage,
   CHMint32 Code
)
{
   ((CHMllpServer*)pLlpServer)->OnErrorReceived(ErrorMessage, Code);
   return 0;
}

static CHMresult CHM_STD_CALL CHMllpServerClientConnected
(
   void* pLlpServer,
   CHMconnectionHandle ClientHandle
)
{
   CHMllpConnection ComplexArg0(ClientHandle);
   ((CHMllpServer*)pLlpServer)->OnClientConnected(ComplexArg0);
   return 0;
}

static CHMresult CHM_STD_CALL CHMllpServerClientDisconnected
(
   void* pLlpServer,
   CHMconnectionHandle ClientHandle
)
{
   CHMllpConnection ComplexArg0(ClientHandle);
   ((CHMllpServer*)pLlpServer)->OnClientDisconnected(ComplexArg0);
   return 0;
}

static CHMresult CHM_STD_CALL CHMllpServerClientErrorReceived
(
   void* pLlpServer,
   CHMconnectionHandle ClientHandle,
   const char* ErrorMessage,
   CHMint32 ErrorCode
)
{
   CHMllpConnection ComplexArg0(ClientHandle);
   ((CHMllpServer*)pLlpServer)->OnClientErrorReceived(ComplexArg0, ErrorMessage, ErrorCode);
   return 0;
}

static CHMresult CHM_STD_CALL CHMllpServerMessageReceived
(
   void* pLlpServer,
   CHMconnectionHandle ClientHandle,
   const char* Message
)
{
   CHMllpConnection ComplexArg0(ClientHandle);
   ((CHMllpServer*)pLlpServer)->OnMessageReceived(ComplexArg0, Message);
   return 0;
}

static CHMresult CHM_STD_CALL CHMllpServerDataIgnored
(
   void* pLlpServer,
   CHMconnectionHandle ClientHandle,
   const char* Data
)
{
   CHMllpConnection ComplexArg0(ClientHandle);
   ((CHMllpServer*)pLlpServer)->OnDataIgnored(ComplexArg0, Data);
   return 0;
}

void CHMllpServer::setup()
{
   static CHMboolean IsSetup=false;
   if (!IsSetup)
   {
      _CHMlistenerSetListenerErrorCallback(CHMllpServerErrorReceived);
      _CHMlistenerSetConnectCallback(CHMllpServerClientConnected);
      _CHMlistenerSetDisconnectCallback(CHMllpServerClientDisconnected);
      _CHMlistenerSetConnectionErrorCallback(CHMllpServerClientErrorReceived);
      _CHMlistenerSetMessageCallback(CHMllpServerMessageReceived);
      _CHMlistenerSetIgnoredDataCallback(CHMllpServerDataIgnored);
      IsSetup = true;
   }
}

