#include <CHM/CHMpreCompHead.h>
#pragma hdrstop

#ifdef CHM_NO_PRECOMPILED_HEADERS
#   include <CHM/CHMllpWrapper.h>
#   include <CHM/CHMstring.h>
#   include <string.h>
#endif

class CHMllpWrapperPrivate
{
public:
   CHMllpWrapperPrivate();
   CHMstring LLPheader, LLPtrailer;
};

CHMllpWrapperPrivate::CHMllpWrapperPrivate()
 : LLPheader(CHM_TEXT("\x0B")), LLPtrailer(CHM_TEXT("\x1C\x0D"))
{
   // do nothing
}

CHMllpWrapper::CHMllpWrapper()
{
   pMember = new CHMllpWrapperPrivate;
}

CHMllpWrapper::~CHMllpWrapper()
{
   delete pMember;
}
   
void CHMllpWrapper::AddWrapper(CHMstring& MessageData)
{
   MessageData = pMember->LLPheader + MessageData + pMember->LLPtrailer;
}

void CHMllpWrapper::setLLPheader(const CHMchar* NewValue)
{
   pMember->LLPheader = NewValue;
}

const CHMchar* CHMllpWrapper::LLPheader() const
{
   return pMember->LLPheader.c_str();
}

void CHMllpWrapper::setLLPtrailer(const CHMchar* NewValue)
{
   pMember->LLPtrailer = NewValue;
}

const CHMchar* CHMllpWrapper::LLPtrailer() const
{
   return pMember->LLPtrailer.c_str();
}

// The routine should remove the read data from the buffer
// set the Message equal to the message data and return True
// if a message is present in the Buffer
// Otherwise just return False and leave the Buffer the same
// Message is undefined.
CHMboolean CHMllpWrapper::DetectMessage
(
   CHMstring& Buffer, 
   CHMstring& Message
)
{
   CHMchar* pBuffer = Buffer.get_buffer();
   CHMchar* StartOfMessage = CHMstrstr(pBuffer, pMember->LLPheader.c_str());

   if (StartOfMessage == NULL) return false;

   CHMchar* EndOfMessage 
               = CHMstrstr(StartOfMessage, pMember->LLPtrailer.c_str());

   if (EndOfMessage == NULL ) return false;

   // okay we found a message - put it into the Message string
   Message = Buffer.substr(StartOfMessage-pBuffer + CHMstrlen(pMember->LLPheader.c_str()), EndOfMessage-StartOfMessage - CHMstrlen(pMember->LLPheader.c_str()));
   // remove the message from the buffer
   Buffer = Buffer.substr(EndOfMessage - pBuffer + CHMstrlen(pMember->LLPtrailer.c_str()));

   return true;
}

