//#include <CHM/CHMmessageClass.h>
//#include <CHM/CHMtableClass.h>
//#include <CHM/CHMerrorClass.h>

//#include <CHM/CHMtable.h>
//#include <CHM/CHMengine.h>
#include <CHM/CHMpreCompHead.h>
#pragma hdrstop

#ifdef CHM_NO_PRECOMPILED_HEADERS
#   include <CHM/CHMmessageClass.h>
#   include <CHM/CHMengine.h>
#   include <CHM/CHMengineClass.h>
#   include <CHM/CHMerrorClass.h>
#endif

class CHMmessagePrivate
{
public:
   CHMmessagePrivate(const CHMengineHandle& iEngineHandle, 
                     size_t iMessageIndex)
    : EngineHandle(iEngineHandle), MessageIndex(iMessageIndex) {}


   ~CHMmessagePrivate() {}
   CHMengineHandle  EngineHandle;
   size_t           MessageIndex;
};

CHMmessage::CHMmessage
(
   const CHMengineHandle& EngineHandle, 
   CHMtableHandle iTableHandle, 
   size_t MessageIndex
) : CHMtable(iTableHandle)
{
   if (iTableHandle == NULL)
   {
      CHM_CHECK_CALL(CHMengineCreateEmptyMessageTable(EngineHandle, MessageIndex, TableHandle()));      
      AddRow();
   }

   pMember = new CHMmessagePrivate(EngineHandle, MessageIndex);
}

CHMmessage::CHMmessage
(
   const CHMengine& Engine, 
   size_t           MessageIndex
) : CHMtable(NULL)
{
   CHM_CHECK_CALL(CHMengineCreateEmptyMessageTable(Engine.EngineHandle(), MessageIndex, TableHandle()));
   AddRow();
   pMember = new CHMmessagePrivate(Engine.EngineHandle(), MessageIndex);
}

CHMmessage::~CHMmessage()
{
   delete pMember;
}

CHMengineHandle CHMmessage::EngineHandle() const
{
   return pMember->EngineHandle;
}
   
const CHMchar* CHMmessage::GenerateFlatWire()  const
{
   const CHMchar* pResult;
   CHM_CHECK_CALL(CHMengineGenerateMessageT(EngineHandle(), 
                                           &pResult,
                                           pMember->MessageIndex,
                                           TableHandle()));
   return pResult;   
}

void CHMmessage::AddRow()
{
   CHMtable::AddRow();
}

