#include <CHM/CHMpreCompHead.h>
#pragma hdrstop

#include <CHM/CHMtableGrammar.h>
#include <CHM/CHMtableGrammarClass.h>
#include <assert.h>

//---------------------------------------------------------------------------------
// implementation private class
class CHMtableGrammarPrivate
{
public:
   CHMtableGrammarPrivate(CHMtableGrammarHandle Handle);
   ~CHMtableGrammarPrivate();

   CHMtableGrammarHandle  TableGrammarHandle;
};

CHMtableGrammarPrivate::CHMtableGrammarPrivate
(
   CHMtableGrammarHandle Handle
) : TableGrammarHandle(Handle) 
{
   assert(Handle != NULL);
}

CHMtableGrammarPrivate::~CHMtableGrammarPrivate()
{
}

//---------------------------------------------------------------------------------
CHMtableGrammar::CHMtableGrammar(CHMtableGrammarHandle Handle) : pMember(NULL)
{  
   pMember = new CHMtableGrammarPrivate(Handle);
}

CHMtableGrammar::CHMtableGrammar() : pMember(NULL)
{
   pMember = new CHMtableGrammarPrivate(NULL);
}
CHMtableGrammar::~CHMtableGrammar()
{
   delete pMember;
}

CHMtableHandle CHMtableGrammar::GetTableGrammarHandle() const
{
   return pMember->TableGrammarHandle; 
}


//------------------------------------------------------------------------------
// interface
//
const CHMchar* CHMtableGrammar::TableGrammarName() const
{
   const CHMchar* pName;
   CHM_CHECK_CALL(CHMtableGrammarGetName(GetTableGrammarHandle(), &pName));
   return pName;
}

size_t CHMtableGrammar::CountOfSubGrammar() const
{
   size_t Count;
   CHM_CHECK_CALL(CHMtableGrammarGetCountOfSubGrammar(GetTableGrammarHandle(), &Count));
   return Count;
}

bool CHMtableGrammar::IsNode() const
{
   size_t Flag;
   CHM_CHECK_CALL(CHMtableGrammarGetIsNode(GetTableGrammarHandle(), &Flag));
   return Flag == 1;
}

CHMtableGrammarHandle CHMtableGrammar::GetSubGrammar(size_t Index) const
{
   CHMtableGrammarHandle handle;
   CHM_CHECK_CALL(CHMtableGrammarGetSubGrammar(GetTableGrammarHandle(), Index, &handle));
   return handle;
}

CHMtableDefinitionHandle CHMtableGrammar::GetTableDefHandle() const
{
   CHMtableDefinitionHandle handle;
   CHM_CHECK_CALL(CHMtableGrammarGetTable(GetTableGrammarHandle(), &handle));
   return handle;
}

CHMstring CHMtableGrammar::Dump() const
{
   CHMstring Dump;
   CHMchar* pBuffer;
   
   CHM_CHECK_CALL(CHMtableDumpT(GetTableGrammarHandle(), &pBuffer));
   Dump = pBuffer;
   CHM_CHECK_CALL(CHMtableFreeBufferT(&pBuffer));

   return Dump;
}
