#ifndef __PREFIXTESTAPPENGINE_H__
#define __PREFIXTESTAPPENGINE_H__

#include <PrefixTest/PrefixTestEngine.h>

class CHMdateTime;

class PrefixTestappEngine : public PrefixTestEngine
{
public:
   PrefixTestappEngine() : PrefixTestEngine() {}
   virtual ~PrefixTestappEngine() {}

   // Begin message callbacks (comment used as an anchor in STG)
   virtual void msgADT_A04(const PrefixTestMsgADT_A04& Message, size_t TransportIndex);
   // End message callbacks (comment used as an anchor in STG)
   // The following lines should be uncommented as part of the tutorial.
   //virtual void msgACK(const HL7MsgACK& Message, size_t TransportIndex);

   // Begin message generation (comment used as an anchor in STG)
   const char* GenerateADT_A04() const;
   // End message generation (comment used as an anchor in STG)
   // The ParseMethod is over-ridden in this class to make
   // it easy for you to log HL7 messages before parsing and
   // also to respond to error conditions by catching
   // exceptions and responding appropriately
   // i.e. generating a NACK message and logging the error.
   virtual void ParseMessage(const CHMchar* pFlatWire, size_t TransportIndex);

   void MakeReturnACK(const CHMchar* pCode, const CHMchar* Description, const CHMdateTime& TimeStamp, size_t TransportIndex);
private:
   PrefixTestappEngine(const PrefixTestappEngine& Original);  // not allowed
   PrefixTestappEngine& operator=(const PrefixTestappEngine & Original);  // not allowed
};
#endif // end of defensive include
