package com.interfaceware.chameleon;

import java.util.*;
import java.io.*;
/**
* This class allows you to connect to hosts and send messages
**/
public class Client
{
   int TransportId;

/**
* Create a Client
* @exception ChameleonException
**/
   public Client()
   {
   }

/**
* Frees the table handle.
* @exception ChameleonException
**/
   protected void finalize() throws ChameleonException
   {
      CloseConnection();
   }


/**
* Connect to a remote host.
* @exception ChameleonException
**/
   public void Connect( String Host, int Port ) throws ChameleonException
   {
      TransportId = NETtransportConnect( Host, Port );
   }

/**
* Send a message
* @exception ChameleonException
**/
   public void SendMessage( String Message ) throws ChameleonException
   {
      NETtransportSendMessage( TransportId, Message );
   }

/**
* Close a connection
* @exception ChameleonException
**/
   public void CloseConnection() throws ChameleonException
   {
      NETtransportCloseConnection( TransportId );
   }

/**
* called when a connection closes
**/
   public void OnClose( int TransportId )
   {
      System.out.println( "Connection Closed" );
   }

/**
* called when a message arrives
**/
   public void OnMessage( int TransportId, String Message )
   {
      System.out.println( "New Message:" );
      System.out.println( Message );
   }

/**
* called when an error occurs
**/
   public void OnTransportError( int TransportId, int ErrorId, String ErrorMessage )
   {
      System.out.println( "Error Occurred:" );
      System.out.println( ErrorMessage );
   }

/**
* called when a connection has been established
**/
   public void OnConnect( int TransportId )
   {
      System.out.println( "Connected" );
   }

   static
   {
      System.loadLibrary("chm_java");
   }
   private native int NETtransportConnect( String Host, int Port ) throws ChameleonException;
   private native void NETtransportSendMessage( int TransportId, String Message ) throws ChameleonException;
   private native void NETtransportCloseConnection( int TransportId ) throws ChameleonException;  
}
