package com.interfaceware.chameleon;
/**
* This class is used in the internal implementation of Chameleon; it handles table columns.   
* Customers should not attempt to use this class directly.
**/
public class Column
{
   private String m_Name;
   private byte   m_DataType;
   
   static
   {
      System.loadLibrary("chm_java");
   }
   
/**
* Construct a Column object with the specified name and data type.
**/
   public Column(String ColumnName, byte DataType)
   {
      m_Name     = ColumnName;
      m_DataType = DataType;
   }

/**
* Get the column name.
**/
   public String name() { return m_Name; }

/**
* Get the column data type.
**/
   public byte   dataType() { return m_DataType; }

/**
* Get the concatenated column name and data type.
* For example, if the column name is "Name" and the data type 
* is string, this method will return "[NameString]".
**/
   public final synchronized String toString()  // overrides Object.toString()
   {
      String Result = m_Name + "[";
      switch (m_DataType)
      {
      case DataType.StringType:
         Result = Result + "String";
         break;
      case DataType.IntegerType:
         Result = Result + "Integer";
         break;
      case DataType.DoubleType:
         Result = Result + "Double";
         break;
      case DataType.DateType:
         Result = Result + "Date";
         break;
      default:
         Result = Result + "Unknown";
      }
      return Result + "]";
   }
}
