package com.interfaceware.chameleon;

/**
* This class implements a dynamic version of the Engine that 
* allows the message tables to be explored dynamically
* rather than relying on stubcode.  This is required
* because {@link Engine Engine} is a pure abstract class.  In order
* to be able to instantiate an Engine-derived object
* without stubcode, this class is provided.
* @see <a href="http://www.interfaceware.com/manual/java_dynamic_interface.html">http://www.interfaceware.com/manual/java_dynamic_interface.html</a>
**/
public class DynamicEngine extends Engine
{
   /** Constructor.
    **/
   public DynamicEngine() throws ChameleonException
   {
      super();
   }

   /** Parse message dynamically.  This allows the user to parse
    * a message without invoking virtual methods in stubcode.  This
    * is useful for auto-acknowledgment.  Note that you must load the visual message definition (VMD) file 
    * before the DynamicEngine can be used, 
    * and you need to create a new {@link Table Table} object before calling
    * this method.
    * @see <a href="http://www.interfaceware.com/manual/java_dynamic_interface.html">http://www.interfaceware.com/manual/java_dynamic_interface.html</a>
    **/
   public int parseMessageDynamically(String Flatwire, Table MessageTable) throws ChameleonException
   {
      return super.parse(Flatwire, MessageTable); 
   }
}
