package com.interfaceware.chameleon;
/**
* This interface handles generating message events. 
* This is not a core part of the Chameleon Java API.
* This interface makes it convenient to load objects that support this interface into
* a combobox.  In older versions of Chameleon, this was used in the generated example
* Java application.
* Current versions of Chameleon no longer use this interface, but it is retained 
* for backwards compatibility.
**/
public interface GenerateMessage
{
/**
* Get the description of the message generator.
**/
   public String description();

/**
* Convert a message into string format using the specified Engine.
* This does it's actual work by invoking the {@link Message#generateMessage generateMessage}
* method on a {@link Message Message} object. 
**/
   public String generateMessage(Engine AEngine) throws ChameleonException; 
}

