package com.interfaceware.chameleon;

import java.util.*;
import java.io.*;
/**
* This class is deprecated and should not be used. 
**/
public class Hl7ClientSocket
{
   long TransportId;

   /**
   * Create a Client for outgoing connections.
   * @exception ChameleonException
   **/
   public Hl7ClientSocket()
   {
      try
      {
         TransportId = NETtransportCreate();
      }
      catch (ChameleonException Error)
      {
         Error.printStackTrace();
         System.out.println( "Error creating client" );
      }
   }

   /**
   * Create a Client from a received connnection.
   * @exception ChameleonException
   **/
   public Hl7ClientSocket( long TransportId_ )
   {
      TransportId = TransportId_;
   }

   /**
   * Frees the connection handle.
   * @exception ChameleonException
   **/
   protected void finalize() throws ChameleonException
   {
      closeConnection();
      NETtransportDestroy( TransportId );
   }

   /**
   * Connect to a remote host.
   * @exception ChameleonException
   **/
   public void connect( String Host, int Port ) throws ChameleonException
   {
      closeConnection();
      NETtransportConnect( TransportId, Host, Port );
   }

   /**
   * Get the raw IP Address
   * @exception ChameleonException
   **/
   public int getIp()
   {
      int Ip = 0;
      try
      {
         Ip = NETtransportGetIpAddress( TransportId );
      }
      catch (ChameleonException Error)
      {
         System.out.println( Error.toString() );
      }
      return Ip;
   }

   /**
   * Get the IP Address as a string
   * @exception ChameleonException
   **/
   public String getAddress()
   {
      String Address = new String();
      try
      {
         int Ip = NETtransportGetIpAddress( TransportId );
         Address += (Ip & 0x000000FF);
         Address += ".";
         Address += (Ip & 0x0000FF00) >> 8;
         Address += ".";
         Address += (Ip & 0x00FF0000) >> 16;
         Address += ".";
         Address += Ip >> 24;
      }
      catch (ChameleonException Error)
      {
         System.out.println( Error.toString() );
      }
      return Address;
   }

   /**
   * Send a message
   * @exception ChameleonException
   **/
   public void sendMessage( String Message ) throws ChameleonException
   {
      NETtransportSendMessage( TransportId, Message );
   }

   /**
   * Close a connection
   * @exception ChameleonException
   **/
   public void closeConnection() throws ChameleonException
   {
      NETtransportCloseConnection( TransportId );
   }

   /**
   * Called when a connection closes
   **/
   public void onClose( long TransportId )
   {
      System.out.println( "Connection Closed" );
   }

   /**
   * Called when a message arrives
   **/
   public void onMessage( long TransportId, String Message )
   {
      System.out.println( "New Message:" );
      System.out.println( Message );
   }

   /**
   * Called when an error occurs
   **/
   public void onTransportError( long TransportId, int ErrorId, String ErrorMessage )
   {
      System.out.println( "Error Occurred:" );
      System.out.println( ErrorMessage );
   }

   /**
   * Called when a connection has been established
   **/
   public void onConnect( long TransportId )
   {
      System.out.println( "Connected" );
   }

   /**
    * Call this method to stop the networking thread.  This is recommended as the application closes 
    * down to have the application shut down gracefully.
    **/
   static public void stopNetworkingThread() throws ChameleonException
   {
      NETstop();
   }

   static
   {
      System.loadLibrary("chm_java");
   }
   private native long NETtransportCreate() throws ChameleonException;
   private native void NETtransportDestroy( long TransportId ) throws ChameleonException;
   private native void NETtransportConnect( long TransportId, String Host, int Port ) throws ChameleonException;
   private native void NETtransportSendMessage( long TransportId, String Message ) throws ChameleonException;
   private native int NETtransportGetIpAddress( long TransportId ) throws ChameleonException;
   private native void NETtransportCloseConnection( long TransportId ) throws ChameleonException;
   static private native void NETstop() throws ChameleonException;
}
