package com.interfaceware.chameleon;

import java.util.*;
import java.io.*;
/**
 * This class is deprecated and should not be used for new applications.
 * This class allows you to connect to hosts and send messages
**/
public class Hl7ServerSocket
{
   long ServerHandle;

/**
* Construct a Server
* @exception ChameleonException
**/
   public Hl7ServerSocket()
   {
      try
      {
         ServerHandle = NETserverCreate();
      }
      catch (ChameleonException Error)
      {
         Error.printStackTrace();
         System.out.println( "Error creating server" );
      }
   }

/**
* Frees the server handle.
* @exception ChameleonException
**/
   protected void finalize() throws ChameleonException
   {
      NETserverDestroy( ServerHandle );
   }

/**
* Makes server listen on a specified port.
* @exception ChameleonException
**/
   public void listen( int Port ) throws ChameleonException
   {
      NETserverListen( ServerHandle, Port );
   }

/**
* Stops the server from listening
* @exception ChameleonException
**/
   public void stopListening() throws ChameleonException
   {
      NETserverStopListening( ServerHandle );
   }

/**
* Send a message
* @exception ChameleonException
**/
   public void sendMessage( long TransportId, String Message ) throws ChameleonException
   {
      NETtransportSendMessage( TransportId, Message );
   }

/**
* Close a connection 
* This does a graceful close which means it is still possible to receive some
* data that has already been sent by the client.  
* For a hard shutdown use hardCloseConnection instead.
* @exception ChameleonException
**/
   public void closeConnection( long TransportId ) throws ChameleonException
   {
      NETtransportCloseConnection( TransportId );
   }

/**
* Close a connection 
* This does a non-graceful close.
* For a graceful shutdown use closeConnection instead.
* @exception ChameleonException
**/
   public void hardCloseConnection( long TransportId ) throws ChameleonException
   {
      NETtransportHardCloseConnection( TransportId );
   }
   
   /**
    * Called when there is a new connection. Should be overridden. 
    **/
   public Hl7ClientSocket onNewConnection( long TransportId )
   {
      System.out.println( "Accepted Connection: " + TransportId );
      return null;
   }

   /**
    * Called when an error occurs.  Should be overridden.
   **/
   public void onError( int ErrorId, String ErrorMessage )
   {
      System.out.println( "Error Occurred:" );
      System.out.println( ErrorMessage );
   }

   /**
    * Called when an error occurs on a connection.  Should be overridden.
    **/
   public void onTransportError( long TransportId, int ErrorId, String ErrorMessage )
   {
      System.out.println( "Error Occurred: " + TransportId );
      System.out.println( ErrorMessage );
   }

   /**
    * Called when a connection closes.  Should be overridden.
    **/
   public void onClose( long TransportId )
   {
      System.out.println( "Connection Closed: " + TransportId );
   }

   /**
    * Called when a message arrives.  Should be overridden.
    **/
   public void onMessage( long TransportId, String Message )
   {
      System.out.println( "New Message: " + TransportId );
      System.out.println( Message );
   }

   
   /**
    * Call this method to stop the networking thread
    **/
   static public void stopNetworkingThread() throws ChameleonException
   {
      NETstop();
   } 

   static
   {
      System.loadLibrary("chm_java");
   }
   private native long NETserverCreate() throws ChameleonException;
   private native void NETserverDestroy( long ServerHandle ) throws ChameleonException;
   private native void NETserverListen( long ServerHandle, int Port ) throws ChameleonException;
   private native void NETserverStopListening( long ServerHandle ) throws ChameleonException;
   private native void NETtransportSendMessage( long TransportId, String Message ) throws ChameleonException;
   private native void NETtransportCloseConnection( long TransportId ) throws ChameleonException;  
   private native void NETtransportHardCloseConnection( long TransportId ) throws ChameleonException;
   static private native void NETstop() throws ChameleonException;
}
