package com.interfaceware.chameleon;
import java.awt.TextArea;
/**
* This class handles log output and ensures that the text 
* area length isn't exceeded.  This is not a core part of the Chameleon Java API.
* This interface is used in the example
* GUI HL7 client and server programs.
**/
public class LogTextArea extends TextArea implements Log
{
/**
* Construct a LogTextArea object with the specified number of rows and columns.
**/
   public LogTextArea(int Rows, int Columns)
   {
      super(Rows, Columns);
   }

/**
* Print the specified string to the text area and go to a newline.
**/
   public void println(String Line)
   {
      // first we check that the length of the text isn't
      // greater than N chars to ensure the windoze
      // text area length isn't exceeded.  (so much for
      // cross platform transparency!)
      String Text = getText();
      if (Text.length() > 20000)
      {
         setText(Text.substring(10000));
      }
      append(Line + '\n');
   }
   static
   {
      System.loadLibrary("chm_java");
   }
}
