package com.interfaceware.chameleon;
import java.net.*;
/**
* The listener interface for handling client socket connect and
* disconnect events and server socket listen, accept and close events.
**/
public interface ServerSocketListener
{
/**
* Invoked when a server socket accepts a client connection.
**/
   public abstract void onAccept();
/**
* Invoked when a server socket starts listening for client connections.
**/
   public abstract void onListen(int PortNumber);
/**
* Invoked when a server socket closes.
**/
   public abstract void onCloseServer(int PortNumber);
/**
* Invoked when a client socket connects.
**/
   public abstract void onClientConnect(Hl7ClientSocket ClientSocket);
/**
* Invoked when a client socket disconnects.
**/
   public abstract void onClientDisconnect(Hl7ClientSocket ClientSocket);
}
