package com.interfaceware.chameleon;

import java.util.Date;
import java.util.Vector;

/** Trivial example of how one can write a class to generate SQL.  This 
 * is not a core part of the Chameleon Java API.  This
 *  class is not supported.
 **/

public class SqlGenerator
{
   Vector m_NameVector;
   Vector m_ValueVector;
   String m_TableName;

   public SqlGenerator(String TableName) 
   {
      m_NameVector = new Vector(); 
      m_ValueVector = new Vector(); 
      m_TableName = TableName;
   }

   public void release()
   {
      m_NameVector  = null;
      m_ValueVector = null;
      m_TableName   = null;
   }

   protected void finalize()
   {
      release();
   }

   public String generateInsertStatement()
   {
      String Statement;
      Statement = "INSERT INTO " + m_TableName + "(";
      for (int ColumnIndex = 0;
           ColumnIndex < m_NameVector.size()-1;
           ColumnIndex++)
      {
         Statement += (String)(m_NameVector.elementAt(ColumnIndex)) + ", ";
      }
      Statement += (String)(m_NameVector.elementAt(m_NameVector.size()-1));
      Statement += ") VALUES (";
      for (int ColumnIndex = 0;
           ColumnIndex < m_NameVector.size()-1;
           ColumnIndex++)
      {
         Statement += (String)m_ValueVector.elementAt(ColumnIndex) + ", ";
      }
      Statement += (String)m_ValueVector.elementAt(m_ValueVector.size()-1);
      Statement += ")";
      return Statement;
   }

   public String generateUpdateStatement()
   {
      String Statement;
      Statement = "UPDATE " + m_TableName + " SET ";
      for (int ColumnIndex = 0;
           ColumnIndex < m_NameVector.size()-1;
           ColumnIndex++)
      {
         Statement += (String)m_NameVector.elementAt(ColumnIndex)
                      + " = " +  (String)m_ValueVector.elementAt(ColumnIndex)
                      + " ,";
      }
      Statement += (String)m_NameVector.elementAt(m_NameVector.size()-1)
                + " = " + (String)m_ValueVector.elementAt(m_NameVector.size()-1);
      return Statement;
   }

   public void setTableName(String TableName)
   {
      m_TableName = TableName;
   }

   public void addStringColumn(String Name, String Value)
   {
      m_NameVector.addElement(Name);
      m_ValueVector.addElement("'" + escapeString(Value) + "'");
   }

   public void addDateTimeColumn(String Name, ChameleonDateTime Value) throws ChameleonException
   {
      m_NameVector.addElement(Name);
      m_ValueVector.addElement("'" + Value.format("%d/%m/%Y %H:%M:%S") + "'");
   }

   public void addDateTimeColumn(String Name, Date Value)
   {
      m_NameVector.addElement(Name);
      m_ValueVector.addElement(formatDate(Value));
   }

   public void addIntegerColumn(String Name, Integer Value)
   {
      m_NameVector.addElement(Name);
      m_ValueVector.addElement(Value.toString());
   }

   public void addDoubleColumn(String Name, Double Value)
   {
      m_NameVector.addElement(Name);
      m_ValueVector.addElement(Value.toString());
   }

   protected String escapeString(String Value)
   {
      return Value; 
   }

   protected String formatDate(Date Value)
   {
      return Value.toString(); 
   }
   static
   {
      System.loadLibrary("chm_java");
   }
}
