package com.interfaceware.chameleon;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
/**
 * This class is deprecated and should not be used for new applications.  It
 * will most likely be removed by about 2010.
 * This class handles TCPIP connections for a server. The
 * constructor instantiates a server socket and which listens for
 * and accepts client connections. Upon accepting a connection, a client
 * socket is created, which is used to instantiate a Connection thread
 * for data input/output.
**/
public class TransportTcpIpServer extends Hl7ServerSocket
{
   protected static final char LINE_FEED = '\n';
   protected static final int DEFAULT_PORT = 8080;

   protected int m_Port;

   protected Log m_Log = null;
   protected ServerSocketListener m_Listener = null;

   protected Wrapper m_Wrapper = null;

   static
   {
      System.loadLibrary("chm_java");
   }
   
   /**
    * Default constructor.
    **/
   public TransportTcpIpServer()
   {
   }

   /**
    * The main constructor.
    **/
   public TransportTcpIpServer(int Port, Wrapper AWrapper)
   {
      m_Port = Port;
      m_Wrapper = AWrapper;
      if (0 == m_Port)
      {
         m_Port = DEFAULT_PORT;
      }
      try
      {
         listen(m_Port);
      }
      catch (ChameleonException Error)
      {
         Error.printStackTrace();
         errorEvent(Error,"Error creating server socket on port" + m_Port);
         System.exit(1);
      }
      listenEvent();
   }

   /**
    * Print a line to the log.
    **/
   protected void println(String Description)
   {
      if (m_Log != null)
      {
         m_Log.println(Description);
      }
   }

   /**
   * Called when there is a new connection.
   **/
   public Hl7ClientSocket onNewConnection( long TransportId )
   {
      System.out.println( "Accepted Connection: " + TransportId );
      if (m_Listener != null)
      {
         m_Listener.onAccept();
      }

      Connection AConnection = new Connection( TransportId, m_Wrapper, m_Log);
      AConnection.addServerSocketListener(m_Listener);
      return AConnection;
   }

   /**
    * Invokes the onListen event on the ServerSocketListener object.
    **/
   protected void listenEvent()
   {
      if (m_Listener != null)
      {
         m_Listener.onListen(m_Port);
      }
   }

   /**
   * Called when an error occurs.
   **/
   public void onError( int ErrorId, String ErrorMessage )
   {
      if (m_Log != null)
      {
         m_Log.println( ErrorMessage );
      }
      else
      {
         System.out.println( ErrorMessage );
      }
   }

   /**
    * Logs an error.
    **/
   protected void errorEvent(Exception Error, String Description)
   {
      if (m_Log != null)
      {
         m_Log.println(Error.toString() + " : " + Description);
      }
      else
      {
         System.out.println(Error.toString() + " : " + Description);
      }
   }

   /**
    * Assign an object which implements ServerSocketListener.
    **/
   public void addServerSocketListener(ServerSocketListener AListener)
   {
      m_Listener = AListener;
   }

   /**
    * Assign an object which implements the Log interface.
    **/
   public void addLog(Log ALog)
   {
      m_Log = ALog;
   }
   /**
    * The TCP/IP port this socket is listening on.
    **/
   public int port()
   {
      return m_Port;
   }
}

