package com.interfaceware.chameleon;

/**
* <b>This class is no longer used but will be supported for backward compatibility.
* New applications should use {@link LlpServer LlpServer} and {@link LlpClient LlpClient}.</b>
* This class handles wrapping and unwrapping of text messages. Since the
* class is abstract, it cannot be instantiated and a specific
* wrapping/unwrapping protocol must be handled by a descendant class.
* 
**/
public abstract class Wrapper
{
   private Engine m_Engine;
/**
* Get the number of messages detected. Each complete message is unwrapped
* and sent to the Engine for parsing.  It returns the number of
* messages detected.
* @see Engine#parseMessage()
**/
   static
   {
      System.loadLibrary("chm_java");
   }
   int checkForMessage(StringBuffer Buffer, Transport ATransport)
   {
      StringBuffer Message = new StringBuffer();
      int CountOfMessage = 0;
      while (detectMessage(Buffer, Message))
      {
         CountOfMessage++;
         try
         {
            onMessage(Message, ATransport);
         }
         catch (ChameleonException Err)
         {
            Err.printStackTrace();
            m_Engine.log().println(Err.toString());
         }
      }
      return CountOfMessage;
   }

   // these two methods need to be implemented for the unwrapping
   // and wrapping of messages.
/**
* This method must be overridden in a descendant class to add a specific
* wrapper to the message data.
**/
   abstract public String addWrapper(String MessageData);

/**
* This method must be overridden in a descendant class to detect the
* beginning and end of a message for a specific wrapper protocol.
* 
* The routine should remove the data read from the buffer,
* set the Message to be equal to the message data, and return <code>true</code>
* if a message is present in the buffer.
* 
* Otherwise it should just return <code>false</code> and not alter the buffer.  In this
* case the Message is undefined.
**/
   abstract public boolean detectMessage(StringBuffer Buffer, StringBuffer Message);

/**
* Send the unwrapped message to the Engine for parsing. 
**/
   void onMessage(StringBuffer MessageData,
                  Transport    ATransport) throws ChameleonException
   {
      if (null != m_Engine)
      {
          m_Engine.parseMessage(MessageData.toString(), ATransport);
      }
   }

/**
* Set the specified engine to parse messages from this wrapper.
**/
   public void setEngine(Engine AEngine)
   {
      m_Engine = AEngine;
   }
/**
* Get the Engine assigned to parse messages for this wrapper.
**/
   public Engine engine()
   {
      return m_Engine;
   }
}
